---
title: RTCPeerConnection.addIceCandidate()
slug: Web/API/RTCPeerConnection/addIceCandidate
tags:
  - API
  - ICE
  - Media
  - Method
  - RTCPeerConnection
  - Reference
  - SDP
  - Web
  - WebRTC
  - WebRTC API
  - addIceCandidate
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">When a web site or app using {{domxref("RTCPeerConnection")}} receives a new ICE candidate from the remote peer over its signaling channel, it delivers the newly-received candidate to the browser's {{Glossary("ICE")}} agent by calling <code><strong>RTCPeerConnection.addIceCandidate()</strong></code>.</span> This adds this new remote candidate to the <code>RTCPeerConnection</code>'s remote description, which describes the state of the remote end of the connection.</p>

<p>If the <code>candidate</code> parameter is missing or a value of <code>null</code> is given when calling <code>addIceCandidate()</code>, the added ICE candidate is an "end-of-candidates" indicator. The same is the case if the value of the specified object's {{domxref("RTCIceCandidate.candidate", "candidate")}} is either missing or an empty string (<code>""</code>), it signals that all remote candidates have been delivered.</p>

<p>The end-of-candidates notification is transmitted to the remote peer using a candidate with an a-line value of <code>end-of-candidates</code>.</p>

<p>During negotiation, your app will likely receive many candidates which you'll deliver to the ICE agent in this way, allowing it to build up a list of potential connection methods. This is covered in more detail in the articles <a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a> and <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>aPromise </em>= <em>pc</em>.addIceCandidate(<em>candidate</em>);

addIceCandidate(<em>candidate</em>, <em>successCallback</em>, <em>failureCallback</em>); {{deprecated_inline}}
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>candidate</code> {{optional_inline}}</dt>
	<dd>
	<p>An object conforming to the {{domxref("RTCIceCandidateInit")}} dictionary, or an {{domxref("RTCIceCandidate")}} object; the contents of the object should be constructed from a message received over the signaling channel, describing a newly received ICE candidate that's ready to be delivered to the local ICE agent.</p>

	<p>If no <code>candidate</code> object is specified, or its value is <code>null</code>, an end-of-candidates signal is sent to the remote peer using the <code>end-of-candidates</code> a-line, formatted like this:</p>

	<pre>a=end-of-candidates</pre>
	</dd>
</dl>

<h3 id="Deprecated_parameters">Deprecated parameters</h3>

<p>In older code and documentation, you may see a callback-based version of this function. This has been deprecated and its use is <strong>strongly</strong> discouraged. You should update any existing code to use the {{jsxref("Promise")}}-based version of <code>addIceCandidate()</code> instead. The parameters for this form of <code>addIceCandidate()</code> are described below, to aid in updating existing code.</p>

<dl>
	<dt><code>successCallback</code> {{deprecated_inline}}</dt>
	<dd>A function to be called when the ICE candidate has been successfully added. This function receives no input parameters and doesn't return a value.</dd>
	<dt><code>failureCallback</code> {{deprecated_inline}}</dt>
	<dd>A function to be called if attempting to add the ICE candidate fails. Receives as input a {{domxref("DOMException")}} object describing why failure occurred.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which is fulfilled when the candidate has been successfully added to the remote peer's description by the ICE agent. The promise does not receive any input parameters.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>When an error occurs while attempting to add the ICE candidate, the {{jsxref("Promise")}} returned by this method is rejected, returning one of the errors below as the {{domxref("DOMException.name", "name")}} attribute in the specified {{domxref("DOMException")}} object passed to the rejection handler.</p>

<dl>
	<dt><code>TypeError</code></dt>
	<dd>The specified candidate's {{domxref("RTCIceCandidate.sdpMid", "sdpMid")}} and {{domxref("RTCIceCandidate.sdpMLineIndex", "sdpMLineIndex")}} are both <code>null</code>.</dd>
	<dt><code>InvalidStateError</code></dt>
	<dd>The <code>RTCPeerConnection</code> currently has no remote peer established ({{domxref("RTCPeerConnection.remoteDescription", "remoteDescription")}} is <code>null</code>).</dd>
	<dt><code>OperationError</code></dt>
	<dd>This can happen for a number of reasons:
	<ul>
		<li>The value specified for {{domxref("RTCIceCandidate.sdpMid", "sdpMid")}} is non-<code>null</code> and doesn't match the media description ID of any media description included within the {{domxref("RTCPeerConnection.remoteDescription", "remoteDescription")}}.</li>
		<li>The specified value of {{domxref("RTCIceCandidate.sdpMLineIndex", "sdpMLineIndex")}} is greater than or equal to the number of media descriptions included in the remote description.</li>
		<li>The specified {{domxref("RTCIceCandidate.usernameFragment", "ufrag")}} doesn't match the <code>ufrag</code> field in any of the remote descriptions being considered.</li>
		<li>One or more of the values in the {{domxref("RTCIceCandidate", "candidate")}} string are invalid or could not be parsed.</li>
		<li>Attempting to add the candidate fails for any reason.<span style="display: none;"> </span></li>
	</ul>
	</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This code snippet shows how to signal ICE candidates across an arbitrary signaling channel.</p>

<pre class="brush: js">// This example assumes that the other peer is using a signaling channel as follows:
//
// pc.onicecandidate = event =&gt; {
//   if (event.candidate) {
//     signalingChannel.send(JSON.stringify({ice: event.candidate})); // "ice" is arbitrary
//   } else {
//     // All ICE candidates have been sent
//   }
// }

signalingChannel.onmessage = receivedString =&gt; {
  const message = JSON.parse(receivedString);
  if (message.ice) {
    // A typical value of ice here might look something like this:
    //
    // {candidate: "candidate:0 1 UDP 2122154243 192.168.1.9 53421 typ host", sdpMid: "0", ...}
    //
    // Pass the whole thing to addIceCandidate:

    pc.addIceCandidate(message.ice).catch(e =&gt; {
      console.log("Failure during addIceCandidate(): " + e.name);
    });
  } else {
    // handle other things you might be signaling, like sdp
  }
}
</pre>

<p>The last candidate to be signaled this way by the remote peer will be a special candidate denoting end-of-candidates. Out of interest, end-of-candidates may be manually indicated as follows:</p>

<pre class="brush: js">pc.addIceCandidate({candidate:''});
</pre>

<p>However, in most cases you won't need to look for this explicitly, since the events driving the {{domxref("RTCPeerConnection")}} will deal with it for you, sending the appropriate events.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{ SpecName('WebRTC 1.0', '#dom-peerconnection-addicecandidate', 'RTCPeerConnection.addIceCandidate()') }}</td>
			<td>{{ Spec2('WebRTC 1.0') }}</td>
			<td>Initial specification.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.addIceCandidate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Architecture">WebRTC architecture overview</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
</ul>
